WebApp/Controllers/DiscountController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApp.BLL.Services;
using WebApp.ViewModels;

namespace WebApp.Controllers
{
    public class DiscountController : Controller
    {
        private DiscountService DiscountService { get; set; }

        public ActionResult Get()
        {
            if (User.IsInRole("special"))
            {
                return RedirectToAction("Index", "Main");
            }

            return View(new CredentialsViewModel());
        }

        [HttpPost]
        public ActionResult Process(CredentialsViewModel credentialsViewModel)
        {
            if (!ModelState.IsValid)
            {
                return View("Get");
            }

            DiscountService.AddUserToSpecialGroup(User.Identity.Name);

            return RedirectToAction("Index", "Main");
        }

        public DiscountController()
        {
            DiscountService = new DiscountService();
        }
    }
}

WebApp/Views/Discount/Get.cshtml
@model WebApp.ViewModels.CredentialsViewModel
@{
    ViewBag.Title = "Get a discount";
}

<h2>Get a discount</h2>

@using (Html.BeginForm("Process", "Discount", FormMethod.Post, new { @class = "form-horizontal" }))
{
    @Html.ValidationSummary(false)
    
    <div class="form-group">
        @Html.Label("Student card number:", new { @class = "col-sm-2 control-label" })
        <div class="col-sm-10">
            @Html.TextBoxFor(t => t.StudentCardNumber, new { @class = "form-control" })
        </div>
    </div>
    
    <div class="form-group">
        <div class="col-sm-offset-2 col-sm-10">
            <button type="submit" class="btn btn-primary">Get discount</button>
        </div>
    </div>
}